%ifndef __AF_BMP__
%define __AF_BMP__

%include "system.asm"
%include "mmx.asm"


;
;     Fosforova obrazkova ASM knihovna
;
;     (c) by Aaka Fosfor, 2007
;     jabber: fosfor@jabber.cz
;     icq: 96560956
;     email: fosfor.software@seznam.cz
;
;     posledni uprava: 9.5.2007
;


; ----------------------------------------------------------------------
;           obsah knihovny
; ----------------------------------------------------------------------


; (void) save_bmp (cs:ds - ASCIIZ)
;	ulozi obrazovku modu 13 do souboru jako BMP, parametrem je jmeno soubrou


; ----------------------------------------------------------------------
;           vnitrni promenne
; ----------------------------------------------------------------------


bmp_file_header:
	db "BM" ; bfType
	dd 65078 ; bfSize
	dw 0, 0 ; bfReserved1 a 2
	dd 1078 ; bfOffBits - ofset dat od zacatku souboru
bmp_bitmap_header:
	dd 40 ; biSize - specifies the size of the BITMAPINFOHEADER structure, in bytes.
	dd 320 ; biWidth - specifies the width of the image, in pixels.
	dd 200 ; biHeight - specifies the height of the image, in pixels.
	dw 1 ; biPlanes - specifies the number of planes of the target device, must be set to zero.
	dw 8 ; biBitCount - specifies the number of bits per pixel.
	dd 0 ; biCompression - Specifies the type of compression, usually set to zero (no compression).
	dd 64000 ; biSizeImage - specifies the size of the image data, in bytes. If there is no compression, it is valid to set this member to zero.
	dd 2834 ; biXPelsPerMeter - specifies the the horizontal pixels per meter on the designated targer device, usually set to zero.
	dd 2834 ; biYPelsPerMeter - specifies the the vertical pixels per meter on the designated targer device, usually set to zero.
	dd 0 ; biClrUsed - specifies the number of colors used in the bitmap, if set to zero the number of colors is calculated using the biBitCount member.
	dd 0 ; biClrImportant - specifies the number of color that are 'important' for the bitmap, if set to zero, all colors are important.
bmp_palet:
	times 1024 db 0


; ----------------------------------------------------------------------
;           vlastni funkce
; ----------------------------------------------------------------------


; save_bmp
; ulozi obrazovku modu 13 do souboru jako BMP, parametrem je jmeno soubrou
; vstup: cs:ds - ASCIIZ; vystup: nic
save_bmp:
	push bx
	push cx
	push dx
	push ds
	push ax

	call sse2_check ; SSE2 instrukce pouzita pri kopidovani dat obrazku

	; otevreme soubor
	mov ah, 3cH
	mov al, 1
	xor cx, cx
	int 21h

	jc near save_bmp_error
	mov bx, ax

	push cs
	pop ds ; datove struktury mame v kodu

	; zapiseme hlavicku
	mov ah, 40h
	mov dx, bmp_file_header
	mov cx, 54 ; delka hlavicky
	int 21h
	jc near save_bmp_error_c

	; ted zapsat paletu...
	mov di, bmp_palet
	xor cl, cl
save_bmp_paleta_cyklus:
	mov dx, 3c7h
	mov al, cl
	out dx, al
	inc dx
	inc dx

	; nacist RGB
	in al, dx
	mov ch, al
	shl ch, 2
	in al, dx
	mov ah, al
	shl ah, 2
	in al, dx
	shl al, 2

	; ulozit BGR
	mov [di], al
	inc di
	mov [di], ah
	inc di
	mov [di], ch
	inc di

	; ulozit alpha byte
	xor al, al
	mov [di], al
	inc di

	inc cl
	jne save_bmp_paleta_cyklus

	mov ah, 40h
	mov dx, bmp_palet
	mov cx, 1024
	int 21h
	jc save_bmp_error_c
	
	; ...a data... (ale sou vzhuru nohama;)
	mov cx, 0a000h
	mov es, cx
	mov si, 64000
save_bmp_data_cyklus:

	; presunout radek z es:si do bmp_paleta
	push bx
	mov bx, bmp_palet
	add bx, 320
save_bmp_data_cyklus_radek:

	; SSE2 verze (128-bit)
	sub si, 16
	movupd xmm0, [es:si]
	sub bx, 16
	movupd [cs:bx], xmm0

	; 32-bit verze
	; sub si, 4
	; mov eax, [es:si]
	; sub bx, 4
	; mov [cs:bx], eax

	cmp bx, bmp_palet
	jne save_bmp_data_cyklus_radek
	pop bx

	mov ah, 40h
	mov dx, bmp_palet
	mov cx, 320
	int 21h
	jc save_bmp_error_c
	cmp si, 0
	jne save_bmp_data_cyklus

	; .. a upravit veci v hlavicce (delka a tak...) - jenom pri kompresi
	
save_bmp_close:
	; zavreme soubor
	mov ah, 3eH
	int 21h

	jc save_bmp_error

	pop ax
save_bmp_error:
	pop ds
	pop dx
	pop cx
	pop bx
	ret

save_bmp_error_c:
	pushf
	push ax
	mov ah, 3eH
	int 21h
	pop ax
	popf

	pop ds
	pop dx
	pop cx
	pop bx
	ret


%endif ;__AF_BMP__