%ifndef __AF_GRAPH__
%define __AF_GRAPH__


;
;     Fosforova graficka ASM knihovna
;
;     (c) by Aaka Fosfor, 2007
;     jabber: fosfor@jabber.cz
;     icq: 96560956
;     email: fosfor.software@seznam.cz
;
;     posledni uprava: 27.3.2007
;


; ----------------------------------------------------------------------
;           obsah knihovny
; ----------------------------------------------------------------------

; (void) save_graph_mode (DS:BX)
;	ulozi aktualni mod obrazovky na misto v pameti DS:BX (byte)
; (void) set_graph_mode (al mod)
;	nastavi mod obrazovky dany v AL
; (void) put_pixel (bx x, al y, ah barva)
;	vykresli bod v modu 320x200 @ 256 barev


; ----------------------------------------------------------------------
;           vlastni funkce
; ----------------------------------------------------------------------


; ulozi aktualni mod obrazovky na misto v pameti DS:BX (byte)
save_graph_mode:
	push ax

	mov ah, 0fh
	push bx
	int 10h
	pop bx
	mov [ds:bx], al
	
	pop ax
	ret

; nastavi mod obrazovky dany v AL
set_graph_mode:
	push ax

	xor ah, ah
	int 10h

	pop ax
	ret

; vykresli bod
;	bx - x     <0;319>
;	al - y     <0;199>
;	ah - barva <0;255>
put_pixel:
	push ax
	push bx
	push cx
	push es

	; adresa graficke pameti
	mov cx, 0a000h
	mov es, cx

	; zaloha barvy
	mov ch, ah

	; ax = al * 320
	mov cl, 160
	mul cl       ; ax = al * cl
	shl ax, 1    ; ax = ax * 2

	; bx = x + 320*y
	add bx, ax

	; vykreslit bod
	mov [es:bx], ch

	pop es
	pop cx
	pop bx
	pop ax
	ret

%endif ;__AF_GRAPH__