%ifndef __AF_INPUT__
%define __AF_INPUT__

;
;     Fosforova vstupni ASM knihovna
;
;     (c) by Aaka Fosfor, 2007
;     jabber: fosfor@jabber.cz
;     icq: 96560956
;     email: fosfor.software@seznam.cz
;
;     posledni uprava: 12.4.2007
;


; ----------------------------------------------------------------------
;           obsah knihovny
; ----------------------------------------------------------------------

; (ax) inkey (void)
;	vrati stisknutou klavesu, pokud neni, vraci 0
; (ax) inkey_wait (void)
;	vrati stisknutou klavesu, pokud neni, ceka na ni
; (void) wait_for_esc (void)
;	ceka, nez se stiskne ESC
; (void) clear_keys (void)
;	vycisti frontu stisknutych klaves


; ----------------------------------------------------------------------
;           vlastni funkce
; ----------------------------------------------------------------------


; v AX vrati stisknutou klavesu, pokud zadna neni, vraci 0
; (al - ascii, pokud nula, pak ah - scan-code)
inkey:
	mov ah, 01h
	int 16h      ; bylo neco stisknuto?
	je inkey_nokey

	xor ah, ah
	int 16h    ; nahrajeme do ax stisknutou klavesu (al - ascii, pokud nula, pak ah - scan-code)
	jmp inkey_end

inkey_nokey:
	xor ax, ax
	jmp inkey_end

inkey_end:
	ret

; v AX vrati stisknutou klavesu, ceka na stisk
; (al - ascii, pokud nula, pak ah - scan-code)
inkey_wait:
	xor ax, ax
	int 16h    ; nahrajeme do ax stisknutou klavesu (al - ascii, pokud nula, pak ah - scan-code)
	ret


; pocka na zmacknuti ESC
wait_for_esc:
	push ax

wait_for_esc_cyklus:
	call inkey
	cmp al, 27
	jne wait_for_esc_cyklus

	pop ax	
	ret

; vycisti frontu stisknutych klaves
clear_keys:
	push ax

clear_keys_start:
	mov ah, 01h
	int 16h      ; bylo neco stisknuto?
	je clear_keys_end

	xor ah, ah
	int 16h    ; precteme klavesu
	jmp clear_keys_start

clear_keys_end:
	pop ax
	ret

%endif ;__AF_INPUT__