%ifndef __AF_MOUSE__
%define __AF_MOUSE__

%include "system.asm"
%include "output.asm"


;
;     Fosforova mysi ASM knihovna
;
;     (c) by Aaka Fosfor, 2007
;     jabber: fosfor@jabber.cz
;     icq: 96560956
;     email: fosfor.software@seznam.cz
;
;     posledni uprava: 8.5.2007
;


; ----------------------------------------------------------------------
;           obsah knihovny
; ----------------------------------------------------------------------


; (void) mouse_check (void)
;	nainicializuje mys, pokud neni pritomna, vyhodi hlasku a skonci program
; (void) mouse_show (void)
;	zobrazi ukazatel mysi
; (void) mouse_hide (void)
;	skryje ukazatel mysi
; (bx tlacitka (0.b - LB, 1.b - RB, 2.b - MB), cx x souradnice, dx y souradnice) mouse_state (void)
;	vraci stav mysi (pouzice a tlacitka)
; (void) mouse_wait_for_release (void)
;	ceka, dokud je stisknuto nejake tlacitko


; ----------------------------------------------------------------------
;           vnitrni promenne
; ----------------------------------------------------------------------


mouse_not_found:
	db "Mys nenalezena.",13,10,"$"


; ----------------------------------------------------------------------
;           vlastni funkce
; ----------------------------------------------------------------------


; mouse_check
; nainicializuje mys, pokud neni pritomna, vyhodi hlasku a skonci program
; vstup/vystup: nic
mouse_check:
	push ax
	push bx

	xor ax, ax
	int 33h
	cmp ax, 0
	jne mouse_check_ok
	print mouse_not_found
	exit 1

mouse_check_ok:
	pop bx
	pop ax
	ret


; mouse_show
; zobrazi ukazatel mysi
; vystup/vystup: nic
mouse_show:
	push ax
	mov ax, 1
	int 33h
	pop ax
	ret


; mouse_hide
; skryje ukazatel mysi
; vystup/vystup: nic
mouse_hide:
	push ax
	mov ax, 2
	int 33h
	pop ax
	ret

; mouse_state
; vraci stav mysi (pouzice a tlacitka)
; vystup: nic
; vystup: bx - tlacitka (0.b - LB, 1.b - RB, 2.b - MB)
;	cx, dx - x,y souradnice
mouse_state:
	push ax
	mov ax, 3
	int 33h
	pop ax
	ret

; mouse_wait_for_release
; ceka, dokud je stisknuto nejake tlacitko
; vstup/vystup: nic
mouse_wait_for_release:
	push ax
mouse_wait_for_release_loop:
	mov ax, 3
	int 33h
	cmp bx, 0
	jne mouse_wait_for_release_loop
	pop ax
	ret


%endif ;__AF_MOUSE__