%ifndef __AF_SYSTEM__
%define __AF_SYSTEM__

%include "output.asm"
%include "system.asm"

;
;     Fosforova systemova ASM knihovna
;
;     (c) by Aaka Fosfor, 2007
;     jabber: fosfor@jabber.cz
;     icq: 96560956
;     email: fosfor.software@seznam.cz
;
;     posledni uprava: 7.5.2007
;


; ----------------------------------------------------------------------
;           obsah knihovny
; ----------------------------------------------------------------------


; (void) io_error (ax cislo_chyby)
;	obsluha DOSove chyby - vypise hlasku a skonci

; makra:
;	exit <cislo errorlevel>
;		ukonci program s navratovym kodem errorlevel


; ----------------------------------------------------------------------
;           makra nad funkcemi
; ----------------------------------------------------------------------

%macro exit 1
	mov ah, 4Ch
	mov al, %1
	int 21h
%endmacro

; ----------------------------------------------------------------------
;           vnitrni promenne
; ----------------------------------------------------------------------


%define EIO_COUNT 8

eio_msg:
	db "Systemova chyba $"
eio1:	db ": Nezname cislo funkce.$"
eio2:	db ": Soubor nenalezen.$"
eio3:	db ": Cesta nenalezena.$"
eio4:	db ": Prilis mnoho otevrenych souboru.$"
eio5:	db ": Neopravneny pristup.$"
eio6:	db ": Nespravny handle.$"
eio7:	db ": Memory control blocks destroyed.$"
eio8:	db ": Nedostatek pameti.$"

eio_addr:
	dw eio1, eio2, eio3, eio4, eio5, eio6, eio7, eio8


; ----------------------------------------------------------------------
;           vlastni funkce
; ----------------------------------------------------------------------


; obsluha DOSove chyby - vypise hlasku a skonci
; vstup - ax (cislo chyby)
io_error:
	print eio_msg
	call print_number
	cmp ax, EIO_COUNT
	ja io_error_no_msg
	dec ax
	add ax, ax
	add ax, eio_addr
	mov bx, ax
	print [bx]
io_error_no_msg:
	print endl
	exit 1

%endif ;__AF_SYSTEM__